package it.volga.ai;

import it.volga.model.Doom;
import it.volga.model.Location;
import it.volga.model.tiles.Portal;
import lombok.val;

import java.util.HashMap;
import java.util.Map;

public class PortalAI extends AI
{

    Map<Portal, Vertex> p = new HashMap<>();

    public PortalAI(Doom model)
    {
        super(model);
    }

    @Override
    public Path solve() throws IntelligenceException
    {
        System.out.println("portal ai");
        for (Vertex vertex : graph.vertices())
        {
            if (vertex.tile() instanceof Portal)
            {
                val portal = (Portal) vertex.tile();
                p.put(portal, vertex);
            }
        }
        //
        for (Map.Entry<Portal, Vertex> portalVertexEntry : p.entrySet())
        {
            graph.chain(portalVertexEntry.getValue(), p.get(portalVertexEntry.getKey().getDual()));
        }
        //
        return graph.shortestPath(graph.spawn(), graph.exit());
    }
}
