package it.volga.controller;

import it.volga.ai.Move;
import it.volga.model.Doom;
import it.volga.view.View;
import lombok.val;

public abstract class Controller
{

    final View view;
    final Doom model;

    public Controller(View view, Doom model)
    {
        this.view = view;
        this.model = model;
    }

    boolean step(final Move move)
    {
        val player = model.player();
        val before = player.at();
        val after = before.translate(move.delta());
        if (model.step(after))
        {
            view.renderTileAt(before);
            Move.neighborhood(after).forEach(view::renderTileAt);
            view.update();
            return true;
        }
        return false;
    }

    public void start()
    {
        this.view.present();
    }

}
