package it.volga.controller;

import it.volga.ai.Move;
import it.volga.model.Doom;
import it.volga.model.GameState;
import it.volga.view.View;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

public class InteractiveController extends Controller implements KeyListener
{

    public InteractiveController(View view, Doom model)
    {
        super(view, model);
    }

    @Override
    public void keyTyped(KeyEvent e)
    {
        // NOP
    }

    @Override
    public void keyReleased(KeyEvent e)
    {
        // NOP
    }

    @Override
    public void keyPressed(KeyEvent e)
    {
        if (model.state() == GameState.WIN)
            return;
        //
        switch (e.getKeyCode())
        {
            case KeyEvent.VK_W:
            case KeyEvent.VK_UP:
            {
                step(Move.UP);
                break;
            }
            case KeyEvent.VK_S:
            case KeyEvent.VK_DOWN:
            {
                step(Move.DOWN);
                break;
            }
            case KeyEvent.VK_A:
            case KeyEvent.VK_LEFT:
            {
                step(Move.LEFT);
                break;
            }
            case KeyEvent.VK_D:
            case KeyEvent.VK_RIGHT:
            {
                step(Move.RIGHT);
                break;
            }
        }
    }

}
