package it.volga.model;

import java.util.Objects;

public class Location
{

    public static Location of(final int row, final int col)
    {
        return new Location(row, col);
    }

    private final int row;
    private final int col;

    private Location(final int row, final int col)
    {
        this.row = row;
        this.col = col;
    }

    public int row()
    {
        return row;
    }

    public int col()
    {
        return col;
    }

    @Override
    public boolean equals(Object o)
    {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Location location = (Location) o;
        return row == location.row &&
                col == location.col;
    }

    public Location copy()
    {
        return Location.of(this.row, this.col);
    }

    @Override
    public String toString()
    {
        return String.format("(%d, %d)", row, col);
    }

    @Override
    public int hashCode()
    {
        return Objects.hash(row, col);
    }

    public Location translate(Location delta)
    {
        return Location.of(this.row + delta.row, this.col + delta.col);
    }

    public Location delta(Location other)
    {
        return Location.of(other.row - this.row, other.col - this.col);
    }

}
