package it.volga.model.tiles;

import it.volga.model.Doom;
import it.volga.model.Location;

public class Button extends Tile
{

    private boolean enabled;

    public Button(char symbol)
    {
        super(symbol);
    }

    @Override
    public boolean tryToStep(Doom model, Location tileAt)
    {
        System.out.println("Нельзя ходить на кнопку");
        return false;
    }

    @Override
    public boolean tryMoveCrateTo()
    {
        System.out.println("Кнопка " + this.symbol() + " активирована, дверь " + this.symbol() + " открыта!");
        this.enabled = true;
        return true;
    }

    @Override
    public boolean isWalkable()
    {
        return false;
    }

    public boolean isEnabled()
    {
        return enabled;
    }

    @Override
    public boolean equals(Object obj)
    {
        if (obj instanceof Button) {
            return ((Button) obj).symbol() == this.symbol();
        }
        return false;
    }

}
