package it.volga.ai;

import it.volga.model.Doom;
import it.volga.model.tiles.Door;
import lombok.val;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

public class AIPolynomial extends AI
{

    private final Map<Vertex, Vertex> doorToKey = new HashMap<>();

    public AIPolynomial(Doom model)
    {
        super(model);
    }

    private String errorMessage(Vertex vertex, int part)
    {
        return String.format("Не получилось сходить %s из %d части.\nИгрок: %s", vertex, part, model.player());
    }

    @Override
    public Path solve() throws IntelligenceException
    {
/*        final Path pathWithKeys = safestPathWithKeys(graph.spawn(), graph.exit(), new LinkedList<>(), new LinkedList<>());
        if (pathWithKeys.totalDamage() < model.player().health())
        {
            for (Path.Node node : pathWithKeys)
            {
                final boolean stepped = model.step(node.getVertex().location());
                if (!stepped)
                    throw new IntelligenceException(errorMessage(node.getVertex(), 1));
            }
            return pathWithKeys;
        }
        //
        final Path.Node[] nodes = pathWithKeys.nodes();
        final Path withHealth = new Path();
        for (int i = 0; i < nodes.length; i++)
        {
            val node = nodes[i];
            withHealth.append(node);
            final boolean stepped = model.step(node.getVertex().location());
            if (!stepped)
                throw new IntelligenceException(errorMessage(node.getVertex(), 2));
            boolean nextMoveWillKill = false;
            if (i + 1 < nodes.length && nodes[i + 1].isFireNode())
            {
                val nextNode = nodes[i + 1];
                val fire = (Fire) nextNode.getVertex().tile();
                if (model.player().health() <= fire.damage())
                    nextMoveWillKill = true;
            }
            //
            if (nextMoveWillKill)
            {
                final Object[] detour = detourForHealth(model.player(), node.getVertex());
                final Path toHealth = (Path) detour[0];
                final List<Key> keysOnHealth = (List<Key>) detour[1];
                final Vertex healthOn = toHealth.get(-1).getVertex();
                final Path backToLast = safestPathWithKeys(healthOn, node.getVertex(), keysOnHealth, new LinkedList<>());
                toHealth.concat(backToLast);
                for (Path.Node inHealing : toHealth)
                {
                    final boolean healingStepped = model.step(inHealing.getVertex().location());
                    if (!healingStepped)
                        throw new IntelligenceException(errorMessage(node.getVertex(), 3));
                }
                withHealth.concat(toHealth);
            }
        }
        return withHealth;*/
        return null; // TODO FIX
    }

//    private Object[] detourForHealth(Player player, Vertex from) throws IntelligenceException
//    {
//        for (Vertex healthVertex : graph.healths())
//        {
//            val inventoryCopy = new LinkedList<>(player.inventory());
//            val path = safestPathWithKeys(from, healthVertex, inventoryCopy, new LinkedList<>());
//            if (!willPathKill(path, player.health()))
//                return new Object[]{path, inventoryCopy};
//        }
//        throw new IntelligenceException("Ближайшая аптечка от " + from.location() + " недостижима с " + player.health());
//    }
//
//    private boolean willPathKill(final Path path, final int health)
//    {
//        int healthPoints = health;
//        for (Path.Node node : path)
//        {
//            if (node.isFireNode())
//            {
//                val fire = (Fire) node.getVertex().tile();
//                healthPoints -= fire.damage();
//                if (healthPoints <= 0)
//                    return true;
//            }
//            else if (node.getVertex().onHealth())
//            {
//                healthPoints = model.player().maxHealth();
//            }
//        }
//        return false;
//    }
//
//    private Path safestPathWithKeys(Vertex from, Vertex to, List<Key> inventory, List<Door> seenDoors) throws IntelligenceException
//    {
//        Path safestPath = null;
//        for (Path safe : graph.safePaths(from, to))
//            if (!safe.containsDoors(seenDoors))
//            {
//                safestPath = safe;
//                break;
//            }
//        //
//        if (safestPath == null)
//            throw new IntelligenceException("Обнаружена циклическа зависимость между дверьми на уровне, пройти невозможно");
//        //
//        val lastClosedDoor = safestPath.lastClosedDoor(inventory);
//        if (lastClosedDoor.isPresent())
//        {
//            val seenDoor = (Door) lastClosedDoor.get().tile();
//            final Vertex respectiveKey = findKeyForDoor(lastClosedDoor.get());
//            val key = (Key) respectiveKey.tile();
//            inventory.add(key);
//            val copy = new LinkedList<Door>(seenDoors);
//            copy.add(seenDoor);
//            return safestPathWithKeys(from, respectiveKey, inventory, copy)
//                    .concat(safestPathWithKeys(respectiveKey, to, inventory, seenDoors));
//        }
//        else
//            return safestPath;
//    }
//
//    private Path shortestPathWithKeys(Vertex from, Vertex to, List<Key> inventory)
//    {
//        val shortest = graph.shortestPath(from, to);
//        val lastClosedDoor = shortest.lastClosedDoor(inventory);
//        if (lastClosedDoor.isPresent())
//        {
//            final Vertex respectiveKey = findKeyForDoor(lastClosedDoor.get());
//            inventory.add((Key) respectiveKey.tile());
//            return shortestPathWithKeys(from, respectiveKey, inventory).concat(shortestPathWithKeys(respectiveKey, to, inventory));
//        }
//        else
//            return shortest;
//    }
//
//    private Vertex findKeyForDoor(Vertex door)
//    {
//        if (doorToKey.containsKey(door))
//            return doorToKey.get(door);
//        //
//        for (Vertex v : graph.vertices())
//        {
//            if (v.onKey())
//            {
//                final Key key = (Key) v.tile();
//                if (key.opens((Door) door.tile()))
//                {
//                    doorToKey.put(door, v);
//                    return v;
//                }
//            }
//        }
//        throw new IllegalStateException("Нет ключа для двери " + door.location());
//    }

}
