package it.volga.model.tiles;

import it.volga.model.Doom;
import it.volga.model.Location;

public class Door extends Tile
{

    private final Button button;

    public Door(char symbol, Button button)
    {
        super(symbol);
        this.button = button;
    }

    public boolean canBeOpenedBy(Button other)
    {
        return other.equals(this.button);
    }

    @Override
    public boolean tryToStep(Doom model, Location tileAt)
    {
        if (isWalkable())
        {
            model.player().step(tileAt);
            System.out.println("Прошёл через дверь " + symbol());
            return true;
        }
        System.out.println("Дверь закрыта");
        return false;
    }

    @Override
    public boolean tryMoveCrateTo()
    {
        System.out.println("Перемещать ящик в дверь нельзя");
        return false;
    }

    @Override
    public boolean isWalkable()
    {
        return button.isEnabled();
    }

    @Override
    public boolean equals(Object o)
    {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Door door = (Door) o;
        return door.symbol() == this.symbol();
    }

    @Override
    public int hashCode()
    {
        return symbol();
    }
}
