package it.volga.model.tiles;

import it.volga.model.Doom;
import it.volga.model.Location;

import java.util.Objects;

public class Portal extends Tile
{

    private Portal dual;

    public Portal(char symbol)
    {
        super(symbol);
    }

    public void setDual(Portal dual)
    {
        this.dual = dual;
    }

    @Override
    public boolean tryToStep(Doom model, Location tileAt)
    {
        model.teleport(dual);
        return true;
    }

    @Override
    public boolean tryMoveCrateTo()
    {
        System.out.println("Ящик не проходит в портал");
        return false;
    }

    @Override
    public boolean isWalkable()
    {
        return true;
    }

    @Override
    public boolean equals(Object o)
    {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Portal portal = (Portal) o;
        return Objects.equals(symbol(), portal.symbol());
    }

    @Override
    public int hashCode()
    {
        return Objects.hash(symbol());
    }
}
